////////////////////////////////////////////////////////////////////
// CR͂^wKĂ݂悤I
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>
#include "FFNNs.h"

#include "Vector3.h"
#include "RK4.h"

////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;

//t
double dt = 0.01;
//x
double v0_min = 0.0;
double v0_max = 30.0;
//ˊpx
double theta_min = 0;
double theta_max = 90;
//d͉x
double g = 10.0;
//
double mass = 1.0;
//RW
double beta = 0;
//SRW
double gamma_min = 0.0;
double gamma_max = 2.0;
//RW
double beta_min = 0.0;
double beta_max = 0.0;

double range_x = 10.0;
double range_z = 10.0;
double range_v = 10.0;
double range_gamma = 2.0;
double range_beta = 1.0;
double range_theta = 90.0;
double range_distance = 10.0;

int _N = int((t_max - t_min) / dt / 50);

////////////////////////////////////////////////////////////////////
// _NX
////////////////////////////////////////////////////////////////////
class Particle : public RK4 {
private:
public:
	//
	double m = 1.0;
	//RW
	double beta = 0.0;
	//SRW
	double gamma = 0.0;
	//d͉x
	double g = 0.0;
	//ۑf[^
	int N = 100;

	double theta;
	double v0;

	int n = 0;
	int id = 0;

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	std::uniform_real_distribution<> rand_real_0_1;
	unsigned int seed = (unsigned)time(NULL) + clock();

	//RXgN^
	Particle() {
		init();
	}
	Particle(double _dt) {
		init(_dt);
	}
	Particle(double _dt, Vector3& _r, Vector3& _v) {
		init(_dt, _r, _v);
	}
	//
	void init() {}
	void init(double _dt) {
		dt = _dt;
		init();
	}
	void init(double _dt, Vector3& _r, Vector3& _v) {
		init(_dt);
		r.copy(_r);
		v.copy(_v);
	}

	//xxNgiK{j
	Vector3 A(double t, Vector3& r, Vector3& v) {
		Vector3 output;
		output.x = -beta / m * v.length() * v.x - gamma / m * v.x;
		output.y = -beta / m * v.length() * v.y - gamma / m * v.y;
		output.z = -beta / m * v.length() * v.z - gamma / m * v.z - g;
		return output;
	};

	//O
	Vector3* rs;
	Vector3* vs;
	//
	void initRecord(int _N) {
		mt.seed(seed + id);
		N = _N;
		rs = new Vector3[N+1];
		vs = new Vector3[N+1];
	}
	void calculate() {

		beta = beta_min + (beta_max - beta_min) * rand_real_0_1(mt);
		gamma = gamma_min + (gamma_max - gamma_min) * rand_real_0_1(mt);
		theta = theta_min + (theta_max - theta_min) * rand_real_0_1(mt);
		v0 = v0_min + (v0_max - v0_min) * rand_real_0_1(mt);

		//ʒuxNgƑxxNg
		r.set(0, 0, 0);
		v.set(v0 * cos(theta / 180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));

		int NN = round((t_max - t_min) / dt);
		for (int i = 0; i <= NN; i++) {
			double t = i * dt;

			if (i % (NN / N) == 0) {

				int nn = i / (NN / N);
				rs[nn].copy(r);
				vs[nn].copy(v);
			}

			//QENb^@ɂ鎞ԔW
			timeEvolution(dt);

			//ʒu̍XV
			r = r + dr;
			//x̍XV
			v = v + dv;

		}

	}
};
////////////////////////////////////////////////////////////////////
// FFNNNXiP̃j[lbg[NjŎgpϐ
////////////////////////////////////////////////////////////////////
std::string post_filename = "_locus_0.5";

//wKȂ̏ꍇ͎̃RgAEgO
//#define NO_LEARNING

//ϑľvZ
int meanN = 1000;

//w
const int layerN = 4;

//j[lbg[N̍\
int structure[layerN] = {
	5,  //͑w̃j[
	500, //ԑw̃j[
	500, //ԑw̃j[
	4  //o͑w̃j[
};
//d݂ƃoCAXq
double weightFactor = 0.5;
double biasFactor = 1.0;

//wK@̎
int typeOfLearning = 0; // 0:Œ, 1:[^@, 2:AdaGrad, 3:RMSprop

//wKp[^
double eta = 0.01;
double mu = 0.5; //1,2,3
double rho = 0.7;//3
double lambda = 0;

//~job`̃TCY
int batch_size = 100;

//wK񐔂̍XV
int delta_iterations = 1000;
//vZlbg[N
const int NNs = 10;

//QNb^IuWFNg̐
Particle particles[NNs];


//////////////////////////////////////////////////
// FFNNNX̔hNX
//////////////////////////////////////////////////
class FFNN_coefficient : public FFNN {
private:
public:
	//tM^֐iÓI֐ƂĒ`j
	void calculateTeacherSignal(double* input, double* output) {}
	void calculateTeacherSignal_inverse(double* output, double* input) {}
	//wKpinputf[^@w肷֐
	void defineInput(int epoch, int batch) {

		if (particles[id].n == structure[0] - 1) {
			particles[id].calculate();
			particles[id].n = 0;
		}
		int n = particles[id].n;
		input[0] = particles[id].gamma / range_gamma;
		input[1] = particles[id].rs[n].x / range_x;
		input[2] = particles[id].rs[n].z / range_z;
		input[3] = particles[id].vs[n].x / range_v;
		input[4] = particles[id].vs[n].z / range_v;

		teacherSignalOutput[0] = particles[id].rs[n + 1].x / range_x;
		teacherSignalOutput[1] = particles[id].rs[n + 1].z / range_z;
		teacherSignalOutput[2] = particles[id].vs[n + 1].x / range_v;
		teacherSignalOutput[3] = particles[id].vs[n + 1].z / range_v;

		particles[id].n++;
	}
	//ݒ肵͂ɑ΂鑹l̕ςvZ֐
	double getMeanLossValue() {

		double sumLoss = 0;
		for (int i = 0; i < meanN; i++) {

			defineInput(0, i%batch_size);

			//j[lbg[N̏vZiPj
			calculateFeedForward();

			sumLoss += lossFunction();

		}
		sumLoss /= double(meanN);

		return sumLoss;
	}
};
//////////////////////////////////////////////////
// FFNNsNX̔hNX
//////////////////////////////////////////////////
class FFNNs_coefficient : public FFNNs {
private:
public:

	FFNNs_coefficient(int _NNs, int _layerN, int* _structure){
	
		init(_NNs, _layerN, _structure);
	
	}
	void initFFNN() {
		nns = new FFNN_coefficient[NNs];
	}
};




int main(void) {

	for (int n = 0; n < NNs; n++) {
		particles[n].id = n;
		particles[n].dt = dt;
		particles[n].g = g;
		particles[n].initRecord (_N);
		particles[n].calculate();
	}

	//std::cout << particles[0].theta << " " << particles[0].gamma << " " << particles[0].v0 << std::endl;
	//for (int i = 0; i < _N; i++) {
	//		std::cout << particles[0].rs[i].x << " " << particles[0].rs[i].z << std::endl;
	//}




	// t@Co̓Xg[̏
	std::ofstream ofs, ofs_L, ofs_weight;
	std::ifstream if_weight;

	//vZێp
	std::ostringstream information;
	information << "#############################" << std::endl;
	information << "## CR͂^̊wKiwKj" << std::endl;
	information << "#############################" << std::endl;
	information << "##jbgF";
	for (int i = 0; i < layerN; i++) {
		information << structure[i];
		if (i != layerN-1) information << "-";
	}
	information << std::endl;
	information << "##wK@F" << typeOfLearning << std::endl;
	information << "##ob`F" << batch_size << std::endl;
	information << "##etaF" << eta << std::endl;
	information << "##muF" << mu << std::endl;
	information << "##rhoF" << rho << std::endl;
	information << "##lambdaF" << lambda << std::endl;
	information << "##weightFactorF" << weightFactor << std::endl;
	information << "##biasFactorF" << biasFactor << std::endl;

	//t@Cwp
	std::ostringstream _filename;
	_filename << "FFNN_F_type" << typeOfLearning << "_";
	for (int i = 0; i < layerN; i++) {
		_filename << structure[i];
		if (i != layerN-1) _filename << "-";
	}
	_filename << post_filename;
	//tH_̐
	_mkdir("output");
	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/" << _filename.str() << ".txt";
	//o̓Xg[ɂt@CI[v
	ofs.open(filename.str());
	ofs << information.str();
	
#ifndef NO_LEARNING
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_epoch.txt";
	//o̓Xg[ɂt@CI[v
	ofs_L.open(filename.str());
	ofs_L << information.str();
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_weight.txt";
	//o̓Xg[ɂt@CI[v
	ofs_weight.open(filename.str());
	ofs_weight << information.str();

#else
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "input/FFNN_F_type0_5-100-4_locus_0.2_weight.txt";
	//o̓Xg[ɂt@CI[v
	if_weight.open(filename.str());
#endif

	FFNNs_coefficient ffnns_coefficient(NNs, layerN, structure);
	ffnns_coefficient.eta = eta;
	ffnns_coefficient.batch_size = batch_size;
	ffnns_coefficient.adoptFactor(weightFactor, biasFactor);
	ffnns_coefficient.typeOfLearning = typeOfLearning;
	ffnns_coefficient.mu = mu;
	ffnns_coefficient.rho = rho;
	ffnns_coefficient.lambda = lambda;

#ifndef NO_LEARNING
	//vJn
	clock_t start = clock();
	int ms, d, h, m, s;
	ofs_L << "####################" << std::endl;
	ofs_L << "#x:G|bN" << std::endl;
	ofs_L << "#y:l" << std::endl;
	ofs_L << "#showLines: false false false false false" << std::endl;
	ofs_L << "#showMarkers: true true true true true" << std::endl;
	ofs_L << "#set logscale y" << std::endl;
	ofs_L << "#xrange:0 " << delta_iterations*100 << " " << delta_iterations * 10 << std::endl;
	for (int epochN = 0; epochN <= 100; epochN++) {


		if (epochN == 0) ffnns_coefficient.iterations = 0;
		else ffnns_coefficient.iterations = delta_iterations;

		ffnns_coefficient.learnNetworks();
		ffnns_coefficient.updateLowerToHigher();

		double top1 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[0]];
		double top2 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[1]];
		double top3 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[2]];
		double top4 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[3]];
		double top5 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[4]];

		ofs_L << delta_iterations * epochN << " " << top1 << " " << top2 << " " << top3 << " " << top4 << " " << top5 << std::endl;
		std::cout << "t = "<< delta_iterations * epochN << std::endl;

		//vI
		clock_t end = clock();
		ms = end - start;
		d = ms / (1000 * 60 * 60 * 24);
		ms -= d * (1000 * 60 * 60 * 24);
		h = ms / (1000 * 60 * 60);
		ms -= h * (1000 * 60 * 60);
		m = ms / (1000 * 60);
		ms -= m * (1000 * 60);
		s = ms / 1000;
		ms -= s * 1000;
		std::cout << "vZԁF" << d << "" << h << "" << m << "" << s << "." << ms << "b" << std::endl;

	}


	ofs_L << "####################" << std::endl;
	ofs_L << "#vZԁF" << d << "" << h << "" << m << "" << s << "." << ms <<"b"  << std::endl;
	ofs_L.close();

#else
	//wKς݃lbg[N̓ǂݍ
	ffnns_coefficient.readDumpNetwork( if_weight );
	ffnns_coefficient.loadNetwork();
	if_weight.close();
#endif

	ofs << "####################" << std::endl;
	ofs << "#x:xW" << std::endl;
	ofs << "#y:zW" << std::endl;
	ofs << "#showLines: true false true false true false true false" << std::endl;
	ofs << "#showMarkers: false true false true false true false true" << std::endl;
	ofs << "#xrange:0 20 2" << std::endl;
	ofs << "#yrange:0 10 1" << std::endl;

	double *teacherSignalOutput = new double[structure[layerN-1]];
	double *output1 = new double[structure[layerN-1]];
	double *input1 = new double[structure[0]];
	double *output2 = new double[structure[layerN - 1]];
	double *input2 = new double[structure[0]];
	double *output3 = new double[structure[layerN - 1]];
	double *input3 = new double[structure[0]];
	double *output4 = new double[structure[layerN - 1]];
	double *input4 = new double[structure[0]];
	double sum = 0;

	double gamma = 1.0;
	double beta = 0.0;
	double theta1 = 15.0;
	double theta2 = 30.0;
	double theta3 = 45.0;
	double theta4 = 60.0;
	double v0 = 20.0;

	ofs << "#dataset:1" << std::endl;

	{
		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta1 / 180.0*M_PI), 0, v0 * sin(theta1 / 180.0*M_PI));
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;

			if(i%5==0) ofs << particle.r.x << " " << particle.r.z << std::endl;

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);
			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;

			if (particle.r.z < 0) break;
		}

	}
	ofs  << std::endl;

	ofs << "#dataset:2" << std::endl;

	input1[0] = gamma / range_gamma;
	input1[1] = 0;
	input1[2] = 0;
	input1[3] = v0 * cos(theta1 / 180.0*M_PI)/range_v;
	input1[4] = v0 * sin(theta1 / 180.0*M_PI) / range_v;
	ofs << 0 << " " << 0 <<  std::endl;

	for (int i = 1; i < _N; i++) {
		ffnns_coefficient.calculateByBestNeuralNetwork(input1, output1);

		double t = t_min + (t_max - t_min) / _N * i;
		ofs  << output1[0]*range_x << " " << output1[1] * range_z << std::endl;
		if (output1[1] * range_z < 0) break;

		input1[0] = gamma / range_gamma;
		input1[1] = output1[0];
		input1[2] = output1[1];
		input1[3] = output1[2];
		input1[4] = output1[3];

	}
	ofs << std::endl;

	
	ofs << "#dataset:3" << std::endl;

	{
		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta2 / 180.0*M_PI), 0, v0 * sin(theta2 / 180.0*M_PI));
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;

			if (i % 5 == 0) ofs << particle.r.x << " " << particle.r.z << std::endl;

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);
			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;

			if (particle.r.z < 0) break;
		}

	}
	ofs << std::endl;

	ofs << "#dataset:4" << std::endl;

	input2[0] = gamma / range_gamma;
	input2[1] = 0;
	input2[2] = 0;
	input2[3] = v0 * cos(theta2 / 180.0*M_PI) / range_v;
	input2[4] = v0 * sin(theta2 / 180.0*M_PI) / range_v;
	ofs << 0 << " " << 0 <<  std::endl;

	for (int i = 1; i < _N; i++) {
		ffnns_coefficient.calculateByBestNeuralNetwork(input2, output2);

		double t = t_min + (t_max - t_min) / _N * i;
		ofs <<output2[0] * range_x << " " << output2[1] * range_z << std::endl;
		if (output2[1] * range_z < 0) break;

		input2[0] = gamma / range_gamma;
		input2[1] = output2[0];
		input2[2] = output2[1];
		input2[3] = output2[2];
		input2[4] = output2[3];

	}
	ofs << std::endl;

	ofs << "#dataset:5" << std::endl;

	{
		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta3 / 180.0*M_PI), 0, v0 * sin(theta3 / 180.0*M_PI));
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;

			if (i % 5 == 0) ofs  << particle.r.x << " " << particle.r.z << std::endl;

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);
			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;

			if (particle.r.z < 0) break;
		}

	}
	ofs << std::endl;

	ofs << "#dataset:6" << std::endl;

	input3[0] = gamma / range_gamma;
	input3[1] = 0;
	input3[2] = 0;
	input3[3] = v0 * cos(theta3 / 180.0*M_PI) / range_v;
	input3[4] = v0 * sin(theta3 / 180.0*M_PI) / range_v;
	ofs << 0 << " " << 0 <<  std::endl;

	for (int i = 1; i < _N; i++) {
		ffnns_coefficient.calculateByBestNeuralNetwork(input3, output3);

		double t = t_min + (t_max - t_min) / _N * i;
		ofs << output3[0] * range_x << " " << output3[1] * range_z<< std::endl;
		if (output3[1] * range_z < 0) break;

		input3[0] = gamma / range_gamma;
		input3[1] = output3[0];
		input3[2] = output3[1];
		input3[3] = output3[2];
		input3[4] = output3[3];

	}
	ofs << std::endl;

	ofs << "#dataset:7" << std::endl;

	{
		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta4 / 180.0*M_PI), 0, v0 * sin(theta4 / 180.0*M_PI));
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;

			if (i % 5 == 0) ofs << particle.r.x << " " << particle.r.z << std::endl;

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);
			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;

			if (particle.r.z < 0) break;
		}

	}
	ofs << std::endl;

	ofs << "#dataset:8" << std::endl;

	input4[0] = gamma / range_gamma;
	input4[1] = 0;
	input4[2] = 0;
	input4[3] = v0 * cos(theta4 / 180.0*M_PI) / range_v;
	input4[4] = v0 * sin(theta4 / 180.0*M_PI) / range_v;
	ofs << 0 << " " << 0 <<  std::endl;

	for (int i = 1; i < _N; i++) {
		ffnns_coefficient.calculateByBestNeuralNetwork(input4, output4);

		double t = t_min + (t_max - t_min) / _N * i;
		ofs << output4[0] * range_x << " " << output4[1] * range_z<< std::endl;
		if (output4[1] * range_z < 0) break;

		input4[0] = gamma / range_gamma;
		input4[1] = output4[0];
		input4[2] = output4[1];
		input4[3] = output4[2];
		input4[4] = output4[3];

	}
	ofs << std::endl;

	//	sum += pow(distance1/ range_distance - output1[0], 2) / 2.0 / 100.0 / 4.0;
	//	sum += pow(distance2/ range_distance - output2[0], 2) / 2.0 / 100.0 / 4.0;
	//	sum += pow(distance3/ range_distance - output3[0], 2) / 2.0 / 100.0 / 4.0;
	//	sum += pow(distance4/ range_distance - output4[0], 2) / 2.0 / 100.0 / 4.0;

	//std::cout << "Loss=" << sum << std::endl;


	ofs.close();

	#ifndef NO_LEARNING
	ffnns_coefficient.dumpNetwork( ofs_weight );
	ofs_weight.close();
	#endif
	std::cout << "finish" << std::endl;
	int b;
	std::cin >> b;
	return b;
}

/*
gccRpC
g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2 -fopenmp
g++ -c FFNNs.cpp -std=c++14 -O2 -fopenmp
g++ -c main.cpp -std=c++14 -O2 -fopenmp
g++ main.o Matrix.o FFNN.o FFNNs.o -fopenmp


g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2
g++ -c FFNNs.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Matrix.o FFNN.o FFNNs.o
*/